

  **************************************************************************
  *                                                                        *
  * PRG MODUL    : XPmanifest.PRG                                          *
  *                                                                        *
  * DATUM IZMENE : 11.11.2009                                              *
  *                                                                        *
  * AUTOR        : Slobodan Stanojevi, Coba, COBA Systems Software        *
  * WEBSITE      : www.cobasystems.com, cobasystems@gmail.com              *
  *                                                                        *
  * PROJEKAT     : Business Account Software Technology - Open Source      *
  * DEO PROJEKTA : BAST CSYSTEMS                                           *
  *                                                                        *
  * CODE BASE    : Alaska Xbase++, eXpress++                               *
  *                                                                        *
  **************************************************************************

#include "Appevent.ch"
#include "Xbp.ch"
#include "Gra.ch"
#include "Font.ch"
#include "color.ch"
#include "common.ch"

#include "xbtsys.ch"    // ako se koristi XbTools++
#include "dcdialog.ch"  // ako se koristi eXpress++

**************************************************************************
FUNCTION XPmanifest()
**************************************************************************
/*

  WindowsXP.manifest
  ------------------------------
  Ova funkcija ukljuuje ili iskljuuje Windows XP izgled kod Xbase++
  aplikacije tako to formira fajl: WindowsXP.manifest za naziv aplikacije
  ili uklanja taj fajl sa diska. Fajl WindowsXP.manifest se moe ugraditi
  u RES fajl aplikacije (u resurse) odnosno u EXE modul aplikacije, ali
  na nekim raunarima aplikacija nee da izvede oderene operacije zbog
  konflikta sa WindowsXP manifestom ( opisano na kraju ovog fajla ),
  pa zbog toga treba u aplikaciji imati mogunost iskljuenja Widows XP
  izgleda kako bi moglo da se radi i u takvim konfliktnim situacijama.
  To je zadatak ove funkcije.

  PRIMENA U XBASE++ APLIKACIJI
  ------------------------------

  MAIN()
   LOCAL RESTART := .F.

  * Na ulazu u aplikaciju:
  * meni kod eXpress++...

   DCMENUITEM "Promena izgleda programa" PARENT oMenu_CFG ;
   ACTION {|| xpmanifest(), RESTART := .T., DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

   ...ili

   * meni kod Xbase++ ...

   oMenu:AddItem( { "Promena izgleda programa", ;
   { || xpmanifest(), RESTART := .T., lExit := .T. } } )


   --- (OVDE IDE KOD APLIKACIJE) ---

  * Na izlasku iz aplikacije,
  * posle GUI redera kod eXpress++ ...

    DCREAD GUI ...

  * ..ili

  * posle event loop kod Xbase++ ...

      // Event loop = Program navigation
      lExit := .F.
      DO WHILE lExit <> .T.
         nEvent := AppEvent( @mp1, @mp2, @oXbp )
         oXbp:HandleEvent( nEvent, mp1, mp2 )
      ENDDO

  * ... restartuj aplikaciju

   IF RESTART=.T.
      * MAIN()                          // ovo ne uitava program.exe.manifest fajl
        qq := RunShell("",AppName(.T.)) // ovo radi, pa ga koristi !
   ENDIF

  RETURN

*/


LOCAL manifest := AppName(.t.)+".manifest"

IF FILE(manifest)=.t.

   DELETE FILE (manifest)
   MsgBox("Windows XP izgled iskljuen","OK")

ELSE
*--------------------------------------------------------------------------
SET CONSOLE OFF
TEXT TO FILE (manifest)
<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<assembly xmlns="urn:schemas-microsoft-com:asm.v1" manifestVersion="1.0">
<assemblyIdentity
    version="1.0.0.0"
    processorArchitecture="X86"
    name="COBASystems.CSYSTEMS.knjigovodstvo"
    type="win32"
/>
<description>Slobodan Stanojevic Coba</description>
<dependency>
    <dependentAssembly>
        <assemblyIdentity
            type="win32"
            name="Microsoft.Windows.Common-Controls"
            version="6.0.0.0"
            processorArchitecture="X86"
            publicKeyToken="6595b64144ccf1df"
            language="*"
        />
    </dependentAssembly>
</dependency>
</assembly>
ENDTEXT
SET CONSOLE ON
*--------------------------------------------------------------------------
   MsgBox("Windows XP izgled ukljuen","OK")

ENDIF
RETURN NIL


//==========================================================================================
// REZULTATI TESTA PRIMENE Microsoft dodatka: WindowsXP.manifest u ALASKA XBASE++ PROGRAME
//==========================================================================================
//
//       V A  N O !!!  ako je WindowsXP.manifest ugraen u EXE RESURSE
//
//       Bilo koji dialog box da se startuje pre DCMULTILINE
//       totalno ubije program DCMULTILINE i ostaje samo Ctrl+Alt+Del
//
//       Isto vai i za prikaz bilo koje ikone iz EXE RESURSA pre starta
//       DCMULTILINE
//
//===========================================================================================
// Utvren problem i testirano: 01-03-2009
// PROBLEM sa WindowsXP.manifest i XbpStatic() Xbase++ 1.7 - DCSTATIC eXpress++ 1.7-1.82
//===========================================================================================
   * cr := chr(13)+chr(10)
   * sTxt := "XBPSTATIC pa i DCSTATIC ne radi kako treba sa"          +cr+;
   *         "        WindowsXP.manifest"                             +cr+;
   *         "pod Windows-om XP i pod Windows-om VISTA."              +cr+;
   *         "U nekim sluajevima start ovih komandi ubije Windows "  +cr+;
   *         "i izlaz je samo sa Ctrl+Alt+Del."                       +cr+;
   *         "U ovom primeru DCSTATIC koja ima ICON blokira"          +cr+;
   *         "DCMULTILINE ako je pozvana pre njega."

//   *** Sluaj A: radi
   *    @ 1,6 DCMULTILINE sTxt SIZE 51,3.6 OBJECT oEdit  // OK

//   *** Sluaj B: NE radi - Windows se blokira - izlazak mogu samo sa - Ctrl+Alt+Del
   *    @ 1,1 DCSTATIC TYPE XBPSTATIC_TYPE_ICON  PIXEL SIZE 32,32 CAPTION icon_flag // (test.ico)
   *    @ 1,6 DCMULTILINE sTxt SIZE 51,3.6 OBJECT oEdit  // CRASH

//   *** Sluaj C: radi
   *    @ 1,1 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX  PIXEL SIZE 32,32
   *    @ 1,6 DCMULTILINE sTxt SIZE 51,3.6 OBJECT oEdit  // OK


//   *** Sluaj C: radi
   *    @ 1,1 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP  PIXEL SIZE 32,32 CAPTION bitmap_flag // (test.bmp)
   *    @ 1,6 DCMULTILINE sTxt SIZE 51,3.6 OBJECT oEdit  // OK

//
// REZIME:
//
// Alaska Xbase++ 1.7 i eXpress++ 1.7
// ----------------------------------
//
// Ako je WindowsXP.manifest ugraen u EXE RESURSE tada ispred poziva XbpMLE() funkciji
// ili DCMULTILINE() funkciji ne sme da se pozove ni jedan dialog box jer program pukne
// bez ikakvih prijavi greki, i izlaz je samo sa Ctrl+Alt+Del. Isto se deava ako je
// u istoj proceduri sa XbpMLE() i DCMULTILINE() uitana i prikazana neka ICO ili BMP iz
// EXE RESURSA (sa BMP se deava retko a sa ICO obavezno)
//
// Identian problem postoji i kada se WindowsXP.manifest ne ugradi u EXE RESURSE ve
// kada se koristi kao eksterni fajl sa nazivom EXE aplikacije:
// aplikacija: PROGRAM.EXE a eksterni manifest fajl:
// RENAME WindowsXP.manifest -> PROGRAM.EXE.manifest
//
// Isti problem javlja se i kod XbpStatic() i DCSTATIC() funkcija.
//
//===========================================================================================
// PROBLEM sa WindowsXP.manifest i XbpStatic() Xbase++ 1.7 - DCSTATIC eXpress++ 1.7-1.82
//===========================================================================================



